unit rek_ss4U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    StringGrid1: TStringGrid;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
type TName = record
             vorname: ShortString;
             nachname: ShortString;
     end;
     TAnschrift = record
                  plz: ShortString;
                  ort: ShortString;
                  strasse_hausnummer: ShortString;
     end;
     TPerson = record
               anrede: ShortString;
               name: TName;
               anschrift: TAnschrift;
     end;

Var
    feld:array[1..10] of TPerson;
    p:TPerson;

const anz:integer=1;


procedure erfassen(var ds:TPerson);
begin
   p.anrede := Form1.Edit1.Text;
   p.name.vorname := Form1.Edit2.Text;
   p.name.nachname := Form1.Edit3.Text;
   p.anschrift.plz := Form1.Edit4.Text;
   p.anschrift.ort := Form1.Edit5.Text;
   p.anschrift.strasse_hausnummer := Form1.Edit6.Text;
end;

procedure saeubern;
begin
with form1 do begin
  Edit1.Text:=' ';
  Edit2.Text:=' ';
  Edit3.Text:=' ';
  Edit4.Text:=' ';
  Edit5.Text:=' ';
  Edit6.Text:=' ';
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if anz > 10 then
  begin
    saeubern;
    ShowMessage('Zulssige Anzahl der Datenstze berschritten!');
    Exit;
  end
  else begin
    erfassen(p);
    feld[anz]:=p;
    saeubern;
    anz:=anz+1;
    Edit1.SetFocus;
  end;  
end;

procedure TForm1.Button2Click(Sender: TObject);
var 
    i:integer;
begin
   StringGrid1.Cells[0,0]:='Anrede';
   StringGrid1.Cells[1,0]:= 'Name';
   StringGrid1.Cells[2,0]:= 'Vorname';
   StringGrid1.Cells[3,0]:=  'Wohnort';
   for i := 1 to anz do
   begin
     p := feld[i];
     StringGrid1.Cells[0,i] := p.anrede;
     StringGrid1.Cells[1,i] := p.name.nachname;
     StringGrid1.Cells[2,i] := p.name.vorname;
     StringGrid1.Cells[3,i] := p.anschrift.ort;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  ds: TPerson;
  i: integer;
  Daten: file of TPerson;
begin
  with SaveDialog1 do
  begin
    DefaultExt := 'dat';
    Title := 'Datenstze speichern';
    Filter := 'Datenfile *.dat| *.dat' + '|Alle Dateien *.*| *.*';
    InitialDir := ExtractFilePath(Application.ExeName);
  end;
  if SaveDialog1.Execute then
  begin
    AssignFile(Daten, SaveDialog1.FileName);
    Rewrite(Daten);
    for i := 1 to 10 do
    begin
      ds := feld[i];
      Write(Daten, ds);
    end;
    CloseFile(Daten);
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  ds: TPerson;
  i: integer;
  Daten: file of TPerson;
begin
  with OpenDialog1 do
  begin
    DefaultExt := 'dat';
    Title := 'Datenfile ffnen';
    Filter := 'Datenfile *.dat| *.dat' + '|Alle Dateien *.*| *.*';
    InitialDir := ExtractFilePath(Application.ExeName);
  end;
  if OpenDialog1.Execute then
  begin
    AssignFile(Daten, OpenDialog1.FileName);
    Reset(Daten);
    StringGrid1.Cells[0,0]:='Anrede';
    StringGrid1.Cells[1,0]:= 'Name';
    StringGrid1.Cells[2,0]:= 'Vorname';
    StringGrid1.Cells[3,0]:=  'Wohnort';
    for i:= 1 to 10 do
    begin
      Read(Daten, ds);
      StringGrid1.Cells[0,i] := ds.anrede;
      StringGrid1.Cells[1,i] := ds.name.nachname;
      StringGrid1.Cells[2,i] := ds.name.vorname;
      StringGrid1.Cells[3,i] := ds.anschrift.ort;
    end;
    CloseFile(Daten);
  end;
end;

end.
